package com.zcxk.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.zcxk.dto.OrgBaseTreeInfoDto;
import com.zcxk.dto.OrgTree;
import com.zcxk.entity.Org;

import java.util.List;

/**
 * 组织(Org)表服务接口
 *
 * @author makejava
 * @since 2020-10-26 14:55:43
 */
public interface OrgService {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    Org selectById(Integer id);


    /**
     * 查询全部
     *
     * @return 对象列表
     */
    List<Org> selectAll();

    /**
     * 通过实体作为筛选条件查询
     *
     * @param org 实例对象
     * @return 对象列表
     */
    List<Org> selectList(Org org);

    /**
     * 新增数据
     *
     * @param org 实例对象
     * @return 影响行数
     */
    int insert(Org org);

    /**
     * 批量新增
     *
     * @param orgs 实例对象的集合
     * @return 影响行数
     */
    int batchInsert(List<Org> orgs);

    /**
     * 修改数据
     *
     * @param org 实例对象
     * @return 修改
     */
    int update(Org org);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    List<String> deleteAll(List<Integer>ids);

    /**
     * 查询总数据数
     *
     * @return 数据总数
     */
    int count();

    IPage<Org> selectPage(Org org, IPage<Org> page);
    List<OrgTree> getTrees(Org org);
    List<OrgTree>getUserTrees(Org org);
    String findParentOrgByChildId(Integer childId);

    Integer countCompanyByUser();
    List<OrgBaseTreeInfoDto> getCompanyByUser(String condition,List<Integer> companyIds);
}